!     Last change:  G    14 Nov 2006    3:22 am
   PROGRAM  VARREC
!-----Essai de l'algorithme pour le calcul de la variance
!     par le procd "calculatrice"
!--------------------------------------------------------
! 28/11/06 ajout prob de signification
      USE MSIMSL
      IMPLICIT NONE
      INTEGER              :: N, I
!     REAL                 :: XBAR, VARI
!     REAL, DIMENSION(100) :: X
      REAL(8)              :: XBAR, VARI
      REAL(8), DIMENSION(100) :: X
! 28/11/06 ajout prob de signification
      REAL(8) :: P
      INTERFACE
         SUBROUTINE VARDEF( X, N, XB, VARI )
           IMPLICIT NONE
           INTEGER, INTENT(IN)            :: N
!           REAL, DIMENSION(N), INTENT(IN) :: X
!           REAL, INTENT(OUT)              :: XB, VARI
            REAL(8), DIMENSION(N), INTENT(IN) :: X
            REAL(8), INTENT(OUT)              :: XB, VARI
         END SUBROUTINE VARDEF
      END INTERFACE
!     INTERFACE
!        REAL(8) FUNCTION ANORDF(X)
!          IMPLICIT NONE
!          REAL(8), INTENT(IN)            :: X
!        END FUNCTION ANORDF
!     END INTERFACE
!-----I N I T I A L I S A T I O N
      DO
        WRITE(*,*) 'Entrez le nbre d''observations puis les donnes'
!       READ(*,*) N
        DO
          READ(*,*) N
        IF( ( N > 0 .AND. N <= 100 ) .OR. N == -999 ) EXIT
         WRITE(*,*) "Erreur de nombre d'observations"
        END DO
        IF( N .EQ. -999) EXIT
        READ(*,*) (X(I), I = 1, N)
!-----T R A I T E M E N T
        CALL VARDEF( X, N, XBAR, VARI)
! 28/11/06 ajout prob de signification
! IL aurait fallu calculer la statistique  part et tester que la variance est bien >0
!       P = ANORDF( XBAR/(SQRT(VARI*(N - 1))) )
! Attention: ANORDF est simple prcision (REAL(4))!!!!!
        P = DNORDF( XBAR/(SQRT(VARI*(N - 1))) )
!-----C L O T U R E
        WRITE(*,*) 'MOYENNE = ', XBAR
        WRITE(*,*) 'VARIANCE = ', VARI
        WRITE(*,*) 'Z =', XBAR/(SQRT(VARI*(N - 1)))
        WRITE(*,*) 'NOUVEAU! PROB A GAUCHE = ', P
      END DO
      STOP
   END PROGRAM VARREC
!========================================================
   SUBROUTINE VARDEF( X, N, XB, VARI )
!--------------------------------------------------------
!     algorithme de calcul de la variance
!     par le procd "calculatrice"
!--------------------------------------------------------
      IMPLICIT NONE
      INTEGER, INTENT(IN)            :: N
!     REAL, DIMENSION(N), INTENT(IN) :: X
!     REAL, INTENT(OUT)              :: XB, VARI
      REAL(8), DIMENSION(N), INTENT(IN) :: X
      REAL(8), INTENT(OUT)              :: XB, VARI
      INTEGER :: I
!     REAL    :: S1, S2
      REAL(8) :: S1, S2
      S1 = 0.0
      S2 = 0.0
      DO  I = 1, N
        S1 = S1 + X(I)
      END DO
      XB = S1/N
      DO  I = 1, N
        S2 = S2 + (X(I) - XB)**2
      END DO
!     VARI = S2/N - XB**2
      VARI = S2/N
      RETURN
   END SUBROUTINE VARDEF
